
/**
 * vdes-template 1.0.1
 */

(function () {
	'use strict';

	var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

	var runtime = {exports: {}};

	(function (module, exports) {
	/**
	 * @vdes-template/parser 1.0.1
	 */

	(function (global, factory) {
	    factory(exports) ;
	}(commonjsGlobal, (function (exports) {
	    /*! art-template@runtime | https://github.com/aui/art-template */
	    var globalThis = typeof self !== 'undefined' ? self
	        : typeof window !== 'undefined' ? window
	            : typeof commonjsGlobal !== 'undefined' ? commonjsGlobal : {};
	    var runtime = Object.create(globalThis);
	    var ESCAPE_REG = /["&'<>]/;
	    /**
	     * 编码模板输出的内容
	     * @param  {any}        content
	     * @return {string}
	     */
	    runtime.$escape = function (content) { return xmlEscape(toString(content)); };
	    /**
	     * 迭代器，支持数组与对象
	     * @param {array|Object} data
	     * @param {function}     callback
	     */
	    runtime.$each = function (data, callback) {
	        if (Array.isArray(data)) {
	            for (var i = 0, len = data.length; i < len; i++) {
	                callback(data[i], i);
	            }
	        }
	        else {
	            for (var i in data) {
	                callback(data[i], i);
	            }
	        }
	    };
	    // 将目标转成字符
	    function toString(value) {
	        if (typeof value !== 'string') {
	            if (value === undefined || value === null) {
	                value = '';
	            }
	            else if (typeof value === 'function') {
	                value = toString(value.call(value));
	            }
	            else {
	                value = JSON.stringify(value);
	            }
	        }
	        return value;
	    }
	    // 编码 HTML 内容
	    function xmlEscape(content) {
	        var html = '' + content;
	        var regexResult = ESCAPE_REG.exec(html);
	        if (!regexResult) {
	            return content;
	        }
	        var result = '';
	        var i, lastIndex, char;
	        for (i = regexResult.index, lastIndex = 0; i < html.length; i++) {
	            switch (html.charCodeAt(i)) {
	                case 34:
	                    char = '&#34;';
	                    break;
	                case 38:
	                    char = '&#38;';
	                    break;
	                case 39:
	                    char = '&#39;';
	                    break;
	                case 60:
	                    char = '&#60;';
	                    break;
	                case 62:
	                    char = '&#62;';
	                    break;
	                default:
	                    continue;
	            }
	            if (lastIndex !== i) {
	                result += html.substring(lastIndex, i);
	            }
	            lastIndex = i + 1;
	            result += char;
	        }
	        if (lastIndex !== i) {
	            return result + html.substring(lastIndex, i);
	        }
	        else {
	            return result;
	        }
	    }

	    exports.runtime = runtime;

	    Object.defineProperty(exports, '__esModule', { value: true });

	})));
	}(runtime, runtime.exports));

	module.exports = runtime.exports.runtime;

}());
